#ifndef __THEME_HPP__
#define __THEME_HPP__

#include <map>
#include <string>

namespace NE
{
    class SpriteLoader;
    class Sprite;
    class SoundLoader;
    class Sound;
}

class Font;

class Theme
{
private:
    NE::SpriteLoader* m_pSpriteLoader;
    NE::SoundLoader* m_pSoundLoader;

    std::map<std::string, NE::Sprite*> m_spritesBank;
    std::map<std::string, Font*> m_fontsBank;
    std::map<std::string, NE::Sound*> m_soundsBank;

public:
    Theme(NE::SpriteLoader* pSpriteLoader, NE::SoundLoader* pSoundLoader);
    ~Theme();

    bool load();

    NE::Sprite* getSprite(const std::string& name);
    Font* getFont(const std::string& name);
    NE::Sound* getSound(const std::string& name);
};

#endif
