/**
OBG_Bounce is a fast release game
Copyright (C) 2011  Alexandre LAURENT

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

website: http://www.developpez.net/forums/d1149377/applications/developpement-2d-3d-jeux/projets/we-jeu-2-participation-littlewhite/#post6329974
e-mail: lw.demoscene@gmail.com
**/

#include "Board.h"

#include "NEngine/Renderer.h"
#include "Engine/Theme.h"

#include "Types/Vec2.h"

#include "Game/Ball.h"

#include <cassert>

Board :: Board()
{
}

bool Board :: load(Theme* pTheme)
{
    assert(pTheme);

    m_pSprite = pTheme->getSprite("background");

    return true;
}

bool Board :: draw(NE::Renderer* pRenderer)
{
    return pRenderer->drawSurface(IVec2(0,0),*m_pSprite);
}

bool Board :: update()
{
    return true;
}

BoardZone Board :: getZone(const Ball* pBall)
{
    assert(pBall);
    IVec2 bPosition = pBall->getPosition();
    bPosition = bPosition + IVec2(10,10); // ball sprite size
    if ( bPosition.x < 35 || 600 - bPosition.x < 10 ||
         bPosition.y < 35 || 600 - bPosition.y < 35 )
    {
        return BZ_Death;
    }

    if ( bPosition.x < 50 || 600 - bPosition.x < 25 ||
         bPosition.y < 50 || 600 - bPosition.y < 50 )
    {
        return BZ_Ossom;
    }

    if ( bPosition.x < 70 || 600 - bPosition.x < 45 ||
         bPosition.y < 70 || 600 - bPosition.y < 70 )
    {
        return BZ_Superb;
    }

    if ( bPosition.x < 120 || 600 - bPosition.x < 95 ||
         bPosition.y < 120 || 600 - bPosition.y < 120 )
    {
        return BZ_Safe;
    }

    return BZ_Lame;
}
