#ifndef __BOARD_HPP__
#define __BOARD_HPP__

/**
OBG_Bounce is a fast release game
Copyright (C) 2011  Alexandre LAURENT

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

website: http://www.developpez.net/forums/d1149377/applications/developpement-2d-3d-jeux/projets/we-jeu-2-participation-littlewhite/#post6329974
e-mail: lw.demoscene@gmail.com
**/

namespace NE
{
    class Renderer;
    class Sprite;
}

class Theme;
class Ball;

enum BoardZone
{
    BZ_Lame,
    BZ_Safe,
    BZ_Superb,
    BZ_Ossom,
    BZ_Ready,
    BZ_Death
};

class Board
{
private:
    NE::Sprite* m_pSprite;

public:
    Board();

    bool load(Theme* pTheme);

    bool draw(NE::Renderer* pRenderer);
    bool update();

    BoardZone getZone(const Ball* pBall);
};

#endif
