#ifndef __GAME_HPP__
#define __GAME_HPP__

/**
OBG_Bounce is a fast release game
Copyright (C) 2011  Alexandre LAURENT

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

website: http://www.developpez.net/forums/d1149377/applications/developpement-2d-3d-jeux/projets/we-jeu-2-participation-littlewhite/#post6329974
e-mail: lw.demoscene@gmail.com
**/

#include "Engine/Theme.h"
#include "Game/Board.h"
#include "Game/Ball.h"
#include "Game/Message.h"
#include "Game/Score.h"

namespace NE { class NEngine; }

class Game
{
private:
    NE::NEngine* m_pNEngine;
    Theme m_theme;

    Board m_board;
    Ball m_ball;
    Message m_message;
    Score m_score;

    // Time management
    unsigned fpsNumber;           /*!< the number of fps (update each second)*/
    unsigned fpsCounter;          /*!< the frame counter */
    unsigned fpsLastUpdateTime;   /*!< the last update time of the fps number */

    unsigned lastUpdateTime;      /*!< the last update time of the loop */
    unsigned lastPressed;
    unsigned playTime;
    bool m_lastButtonState;       /*!< true if the button was pressed */
    bool m_isPlaying;

    bool draw();
    bool update();

public:
    Game(NE::NEngine* pNEngine);

    bool load();

    void run();
};

#endif
