/**
OBG_Bounce is a fast release game
Copyright (C) 2011  Alexandre LAURENT

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

website: http://www.developpez.net/forums/d1149377/applications/developpement-2d-3d-jeux/projets/we-jeu-2-participation-littlewhite/#post6329974
e-mail: lw.demoscene@gmail.com
**/

#include "Message.h"

#include "NEngine/Renderer.h"

#include "Engine/Theme.h"

#include <cassert>

Message :: Message()
    :positionSafe(600/2 - 90 /2, 600/2 - 26/2),
    positionSuperb(600/2 - 295 /2, 600/2 - 55/2),
    positionOssom(600/2 - 400 /2, 600/2 - 150/2),
    positionMessage(600/2 - 300 /2, 600/2 - 150/2),
    m_actualBZone(BZ_Lame),
    m_actualTime(0)

{
}

bool Message :: load(Theme* pTheme)
{
    assert(pTheme);

    m_pSpriteOssom = pTheme->getSprite("ossom");
    m_pSpriteSuperb = pTheme->getSprite("superb");
    m_pSpriteSafe = pTheme->getSprite("safe");
    m_pSpriteGameOver = pTheme->getSprite("gameover");
    m_pSpriteReady = pTheme->getSprite("ready");

    return true;
}

bool Message :: draw(NE::Renderer* pRenderer)
{
    if ( m_displayed )
    {
        switch ( m_actualBZone )
        {
            case BZ_Safe:
                return pRenderer->drawSurface(positionSafe,*m_pSpriteSafe);
                break;
            case BZ_Superb:
                return pRenderer->drawSurface(positionSuperb,*m_pSpriteSuperb);
                break;
            case BZ_Ossom:
                return pRenderer->drawSurface(positionOssom,*m_pSpriteOssom);
                break;
            case BZ_Ready:
                return pRenderer->drawSurface(positionMessage,*m_pSpriteReady);
                break;
            case BZ_Death:
                return pRenderer->drawSurface(positionMessage,*m_pSpriteGameOver);
                break;
        }
    }

    return true;
}

void Message :: update(unsigned actualTime)
{
    if ( m_actualBZone != BZ_Ready && m_actualBZone != BZ_Death )
    {
        if ( actualTime - m_actualTime > 500 )
        {
            m_displayed = false;
        }
    }
}

void Message :: setMessage(BoardZone bZone, unsigned actualTime)
{
    m_actualBZone = bZone;
    m_actualTime = actualTime;
    m_displayed = true;
}
