#ifndef __MESSAGE_H__
#define __MESSAGE_H__

/**
OBG_Bounce is a fast release game
Copyright (C) 2011  Alexandre LAURENT

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

website: http://www.developpez.net/forums/d1149377/applications/developpement-2d-3d-jeux/projets/we-jeu-2-participation-littlewhite/#post6329974
e-mail: lw.demoscene@gmail.com
**/

#include "Game/Board.h"

#include "Types/Vec2.h"

namespace NE
{
    class Renderer;
    class Sprite;
}

class Theme;

class Message
{
private:
    NE::Sprite* m_pSpriteOssom;
    NE::Sprite* m_pSpriteSuperb;
    NE::Sprite* m_pSpriteSafe;
    NE::Sprite* m_pSpriteGameOver;
    NE::Sprite* m_pSpriteReady;

    IVec2 positionSafe;
    IVec2 positionSuperb;
    IVec2 positionOssom;
    IVec2 positionMessage;

    BoardZone m_actualBZone;

    bool m_displayed;
    unsigned m_actualTime;

public:
    Message();

    bool load(Theme* pTheme);

    bool draw(NE::Renderer* pRenderer);
    void update(unsigned actualTime);

    void setMessage(BoardZone bZone, unsigned time);
};

#endif
